<?php
//
//namespace App\Http\Resources;
//
//use Carbon\Carbon;
//use Carbon\CarbonInterval;
//use Exception;
//use Illuminate\Http\Request;
//use Illuminate\Http\Resources\Json\JsonResource;
//use Illuminate\Support\Collection;
//use Illuminate\Support\Facades\Log;
//
//class FlightOffersResource extends JsonResource
//{
//    protected Collection $catalogProductOfferings;
//    protected Collection $catalogProductOffering;
//    protected Collection $referenceList;
//    protected string $transactionId;
//
//    public function __construct($resource)
//    {
//        parent::__construct($resource);
//
//        $this->catalogProductOfferings = new Collection(
//            collect($this['CatalogProductOfferingsResponse']['CatalogProductOfferings'])
//        );
//        $this->transactionId = $this->catalogProductOfferings['Identifier']['value'];
//        $this->catalogProductOffering = new Collection($this->catalogProductOfferings['CatalogProductOffering']);
//        $this->referenceList = new Collection(collect($this['CatalogProductOfferingsResponse']['ReferenceList']));
//    }
//
//    public function toArray(Request $request): array
//    {
////        return $this->extractProductOffers();
//        return $this->generateCombinableOffers();
//    }
//
//    protected function generateCombinableOffers(): array
//    {
//        $productOffers = $this->catalogProductOffering->flatMap(function ($offer) {
//            return collect($offer['ProductBrandOptions'])->flatMap(
//                function ($productOption) use ($offer) {
//
//                    return $this->generateBrandOptions($offer, $productOption);
//                });
//        });
//
//        return $productOffers->groupBy('combinabilityCode')->toArray();
//    }
//
//    protected function generateBrandOptions($offer, $productOption): Collection
//    {
//        return collect($productOption['ProductBrandOffering'])->flatMap(
//            function ($productBrandOffering) use ($offer) {
//
//                return $this->generateProductBrands($productBrandOffering, $offer);
//            });
//    }
//
//    protected function generateProductBrands($productBrandOffering, $offer): Collection
//    {
//        return collect($productBrandOffering['CombinabilityCode'])->map(
//            function ($combinabilityCode) use ($offer, $productBrandOffering) {
//
//                return $this->generateOfferProduct($combinabilityCode, $offer, $productBrandOffering);
//            });
//    }
//
//    protected function generateOfferProduct($combinabilityCode, $offer, $productBrandOffering): array
//    {
//        $productIAir = $this->extractProductAirFromReferenceList(
//            $productBrandOffering['Product'][0]['productRef']
//        );
//
//        $flightSegments = new Collection($productIAir['FlightSegment']);
//
//        $flightSegments = $this->addFlightDetailsToSegments($flightSegments);
//
//        $segmentDetails = $this->extractFlightSegmentDetails($flightSegments);
//
//        $durations = $this->calculateProductDurations($productIAir);
//
//        return [
//            '@type' => intval($offer['sequence']) === 1 ? 'Outbound' : 'Inbound',
//            'combinabilityCode' => $combinabilityCode,
//            'catalogProductOfferingsIdentifier' => $this->transactionId,
//            'authority' => $offer['Identifier']['authority'] ?? "GDS",
//            'offerId' => $offer['id'],
//            'id' => $productBrandOffering['Product'][0]['productRef'],
//            'fromAirport' => $offer['Departure'],
//            'fromAirportCarrierCode' => $segmentDetails['fromAirportCarrierCode'],
//            'fromAirportAircraftCode' => $segmentDetails['fromAirportAircraftCode'],
//            'toAirport' => $offer['Arrival'],
//            'toAirportCarrierCode' => $segmentDetails['toAirportCarrierCode'],
//            'toAirportAircraftCode' => $segmentDetails['toAirportAircraftCode'],
//            'originDepartureTime' => $segmentDetails['originDepartureTime'],
//            'destinationArrivalTime' => $segmentDetails['destinationArrivalTime'],
//            'duration' => $durations['Duration'],
//            'numberOfStops' => $flightSegments->count() - 1,
//            'numberOfBookableSeats' => $productIAir['Quantity'] ?? 0,
//            'segments' => $flightSegments->toArray(),
//            'durationInHours' => $durations['Hours'],
//            'price' => $productBrandOffering['Price'],
//            'bestCombinablePrice' => $productBrandOffering['BestCombinablePrice'],
//            'productAir' => $productIAir,
//        ];
//    }
//
//    protected function extractProductOffers(): array
//    {
//        ini_set('max_execution_time', 0);
//        try {
//            $productOffers = new Collection;
//
//            foreach ($this->catalogProductOffering as $index => $offer) {
//                foreach ($offer['ProductBrandOptions'] as $optionIndex => $productOption) {
//                    foreach ($productOption['ProductBrandOffering'] as $productBrandOffering) {
//
////                        $flightSegments = $this->getReferenceListFlightSegments($productOption['flightRefs']);
//                        $productIAir = $this->extractProductAirFromReferenceList(
//                            $productBrandOffering['Product'][0]['productRef']
//                        );
//
//                        $flightSegments = new Collection($productIAir['FlightSegment']);
//
//                        $flightSegments = $this->addFlightDetailsToSegments($flightSegments);
//
//                        $segmentDetails = $this->extractFlightSegmentDetails($flightSegments);
//
//                        $durations = $this->calculateProductDurations($productIAir);
//
//                        foreach ($productBrandOffering['CombinabilityCode'] as $combinabilityCode) {
//                            $offerProduct = [
//                                '@type' => intval($offer['sequence']) === 1 ? 'Outbound' : 'Inbound',
//                                'combinabilityCode' => $combinabilityCode,
//                                'catalogProductOfferingsIdentifier' => $this->transactionId,
//                                'authority' => $offer['Identifier']['authority'] ?? "GDS",
//                                'offerId' => $offer['id'],
//                                'id' => $productBrandOffering['Product'][0]['productRef'],
//                                'fromAirport' => $offer['Departure'],
//                                'fromAirportCarrierCode' => $segmentDetails['fromAirportCarrierCode'],
//                                'fromAirportAircraftCode' => $segmentDetails['fromAirportAircraftCode'],
////                            'fromAirline' => "",
//                                'toAirport' => $offer['Arrival'],
//                                'toAirportCarrierCode' => $segmentDetails['toAirportCarrierCode'],
//                                'toAirportAircraftCode' => $segmentDetails['toAirportAircraftCode'],
////                            'lastTicketingDate' => "",
//                                'originDepartureTime' => $segmentDetails['originDepartureTime'],
//                                'destinationArrivalTime' => $segmentDetails['destinationArrivalTime'],
//                                'duration' => $durations['Duration'],
//                                'numberOfStops' => $flightSegments->count() - 1,
//                                'numberOfBookableSeats' => $productIAir['Quantity'] ?? 0,
//                                'segments' => $flightSegments->toArray(),
//                                'durationInHours' => $durations['Hours'],
//                                'price' => $productBrandOffering['Price'],
//                                'bestCombinablePrice' => $productBrandOffering['BestCombinablePrice'],
//                                'productAir' => $productIAir,
//                            ];
//
//                            $productOffers->add($offerProduct);
//                        }
//                    }
//                }
//            }
//
//            return $productOffers->groupBy('combinabilityCode')->toArray();
//        } catch (Exception $e) {
//            Log::error('Error in FlightOffersResource: ' . $e->getMessage());
//            return ['error' => $e->getMessage()];
//        }
//    }
//
//    protected function getReferenceListFlightSegments(array $flightRefs): Collection
//    {
//        $flightSegments = new Collection;
//        $referenceFlights = new Collection(
//            $this->referenceList->where("@type", "ReferenceListFlight")->first()['Flight']
//        );
//
//        foreach ($flightRefs as $ref) {
//            $segment = $referenceFlights->where('id', $ref)->first();
//            $flightSegments->add($segment);
//        }
//
//        return $flightSegments;
//    }
//
//    protected function extractProductAirFromReferenceList(string $productRef)
//    {
//        $productAirList = new Collection(
//            $this->referenceList->where("@type", "ReferenceListProduct")->first()["Product"]
//        );
//
//        return $productAirList->where("id", $productRef)->first();
//    }
//
//    protected function extractFlightSegmentDetails(Collection $segments): array
//    {
//        $duration = $this->calculateDirectionDuration($segments);
//
//        $firstFlight = Collection::wrap($segments->first()["FlightDetails"]);
//        $lastFlight = Collection::wrap($segments->last()["FlightDetails"]);
//        return [
//            'originDepartureTime' => $this->getDepartureOrArrivalTime($firstFlight, direction: "Departure"),
//            'destinationArrivalTime' => $this->getDepartureOrArrivalTime($lastFlight, direction: "Arrival"),
//            'duration' => $duration['Duration'],
//            'durationInHours' => $duration['Hours'],
//            'fromAirportCarrierCode' => $firstFlight['carrier'],
//            'toAirportCarrierCode' => $lastFlight['carrier'],
//            'fromAirportAircraftCode' => $firstFlight['equipment'],
//            'toAirportAircraftCode' => $lastFlight['equipment'],
//            'fromAirline' => isset($lastFlight['operatingCarrierName'])
//                ? $lastFlight['operatingCarrierName']
//                : "",
//        ];
//    }
//
//    private function getDepartureOrArrivalTime(Collection $firstFlight, string $direction): string
//    {
//        $departureDate = $firstFlight->get($direction)['date'];
//        $departureTime = $firstFlight->get($direction)['time'];
//
//        return Carbon::createFromFormat('Y-m-d H:i:s', $departureDate . ' ' . $departureTime)->toISOString();
//    }
//
//    protected function calculateDirectionDuration(Collection $segments): array
//    {
//        try {
//            $durations = $segments->pluck('FlightDetails.duration');
//
//
//            $totalHours = 0;
//            $totalMinutes = 0;
//
//            $durations->each(function ($durationString) use (&$totalHours, &$totalMinutes) {
//                $duration = CarbonInterval::fromString($durationString);
//                $totalHours += $duration->hours;
//                $totalMinutes += $duration->minutes;
//            });
//
//            $totalHours += floor($totalMinutes / 60);
//            $totalMinutes = $totalMinutes % 60;
//
//            $durationHours = $totalHours + ($totalMinutes ? $totalMinutes / 60 : 0);
//
//            return ["Duration" => "PT{$totalHours}H{$totalMinutes}M", "Hours" => $durationHours];
//
//        } catch (Exception $e) {
//            return ["Duration" => "", "Hours" => ""];
//        }
//    }
//
//    protected function calculateProductDurations(array $productAir): array
//    {
//        try {
//            $totalHours = 0;
//            $totalMinutes = 0;
//
//            $totalDuration = CarbonInterval::fromString($productAir["totalDuration"]);
//
//            $totalHours += $totalDuration->hours;
//            $totalMinutes += $totalDuration->minutes;
//
//            $totalHours += floor($totalMinutes / 60);
//            $totalMinutes = $totalMinutes % 60;
//
//            $durationHours = $totalHours + ($totalMinutes ? $totalMinutes / 60 : 0);
//
//            return ["Duration" => $productAir["totalDuration"], "Hours" => $durationHours];
//
//        } catch (Exception $e) {
//            return ["Duration" => "", "Hours" => ""];
//        }
//    }
//
//    protected function addFlightDetailsToSegments(Collection $flightSegments): Collection
//    {
//        $referenceFlights = new Collection(
//            $this->referenceList->where("@type", "ReferenceListFlight")->first()['Flight']
//        );
//
//        return $flightSegments->map(function ($segment) use ($referenceFlights) {
//            $flightDetails = $referenceFlights->where('id', $segment['Flight']['FlightRef'])->first();
//
//            $segment['FlightDetails'] = $flightDetails;
//
//            return $segment;
//        });
//    }
//}
